
--
-- For All available Widgets
--
CREATE TABLE IF NOT EXISTS `qo-widgets` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `launcher` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `version` varchar(30) NOT NULL,
  `author` varchar(255) NOT NULL,
  `IconPreview` varchar(255) NOT NULL,
  `file_js` varchar(255) NOT NULL,
  `file_css` varchar(255) NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

--
-- For Widgets configuration
--
CREATE TABLE IF NOT EXISTS `qo-widgets-conf` (
  `id` varchar(255) NOT NULL,
  `launcher` varchar(255) NOT NULL,
  `posX` int(11) NOT NULL,
  `posY` int(11) NOT NULL,
  `wHeight` int(11) default NULL,
  `wWidth` int(11) default NULL,
  `member_id` int(11) NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- For Notes Widget
--
CREATE TABLE IF NOT EXISTS `qo-widgets-notes` (
  `id` varchar(255) NOT NULL,
  `note` text NOT NULL,
  `member_id` int(11) NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

--
-- For Weather Widget
--
CREATE TABLE IF NOT EXISTS `qo-widgets-weather` (
  `id` varchar(255) NOT NULL,
  `IdentCity` varchar(50) NOT NULL,
  `units` enum('metric','english') NOT NULL default 'metric',
  `member_id` int(11) NOT NULL,
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------------------------------------------------------
-- Add All widgets to Widgets Manager
-- ----------------------------------------------------------------------------
INSERT INTO `qo-widgets` (`id`, `launcher`, `title`, `description`, `version`, `author`, `IconPreview`, `file_js`, `file_css`) VALUES
(1, 'clock', 'Clock', 'A simple analogic clock', '0.1', 'Yannick Torr&egrave;s', 'system/modules/qo-widgets/widgets/clock/images/icon.png', 'system/modules/qo-widgets/widgets/clock/clock.js', 'system/modules/qo-widgets/widgets/clock/clock.css'),
(2, 'digitalClock', 'Digital Clock', 'A simple digital clock', '0.1', 'Yannick Torr&egrave;s', 'system/modules/qo-widgets/widgets/clock_digital/images/icon.png', 'system/modules/qo-widgets/widgets/clock_digital/clock_digital.js', 'system/modules/qo-widgets/widgets/clock_digital/clock_digital.css'),
(3, 'Notes', 'Notes', 'A note''s widget', '0.1', 'Yannick Torr&egrave;s', 'system/modules/qo-widgets/widgets/notes/images/icon.png', 'system/modules/qo-widgets/widgets/notes/notes.js', ''),
(4, 'FrTvProgram', 'French TV Program', 'Display French TV Program', '0.1', 'Yannick Torr&egrave;s', 'system/modules/qo-widgets/widgets/french_tv_program/images/icon.jpg', 'system/modules/qo-widgets/widgets/french_tv_program/french_tv_program.js', 'system/modules/qo-widgets/widgets/french_tv_program/french_tv_program.css'),
(5, 'flashCalc', 'Flash Calculator', 'A flash calculator', '0.1', 'Yannick Torr&egrave;s', 'system/modules/qo-widgets/widgets/flash_calc/images/icon.png', 'system/modules/qo-widgets/widgets/flash_calc/flash_calc.js', ''),
(6, 'weather', 'Weather', 'A simple weather''s widget', '0.1', 'Yannick Torr&egrave;s', 'system/modules/qo-widgets/widgets/weather/images/icon.png', 'system/modules/qo-widgets/widgets/weather/weather.js', 'system/modules/qo-widgets/widgets/weather/weather.css');


-- ----------------------------------------------------------------------------
-- Add Qo-Widgets to qo_modules
-- ----------------------------------------------------------------------------
INSERT INTO `qo_modules` (
        `directory`,
        `author`,
        `version`,
        `url`,
        `description`,
        `class_name`,
        `module_type`,
        `module_id`,
        `menu_path`,
        `launcher_icon_cls`,
        `launcher_shortcut_icon_cls`,
        `launcher_text`,
        `launcher_tooltip`,
        `active`,
        `preload`
) VALUES (
        'qo-widgets/',
        'Yannick Torrès',
        '0.1',
        'http://qo-modules.tuxfamily.org/',
	'Widgets',
	'QoDesk.QoWidgets',
	'widgets',
	'qo-widgets',
        'StartMenu/Tools',
        'qo-widgets-icon',
        'qo-widgets-shortcut-icon',
        'Widgets',
        '<b>Widgets</b><br />Some widgets for your Desktop !',
        1,
        0
);
-- ----------------------------------------------------------------------------
-- Add files to qo_modules_files & qo_modules_stylesheets
-- ----------------------------------------------------------------------------
insert into `qo_modules_files` (`qo_modules_id`, `directory`, `file`)
select m.id, 'qo-widgets/', 'qo-widgets.js'
from (select id from qo_modules where module_id like 'qo-widgets') m;

insert into `qo_modules_stylesheets` (`qo_modules_id`, `directory`, `file`)
select m.id, 'qo-widgets/', 'qo-widgets.css'
from (select id from qo_modules where module_id like 'qo-widgets') m;

-- ----------------------------------------------------------------------------
-- Add dependencies to qo_modules_dependencies
-- ----------------------------------------------------------------------------
insert into `qo_modules_dependencies` (`qo_modules_id`, `directory`, `file`)
select m.id, 'qo-widgets/ux/winDrawers/', 'drawer.js'
from (select id from qo_modules where module_id like 'qo-widgets') m;

-- ----------------------------------------------------------------------------
-- Add modules to all group
-- ----------------------------------------------------------------------------
insert into `qo_groups_has_modules` (`qo_groups_id`, `qo_modules_id`, `active`)
select g.id, m.id, 1
from (select id from qo_groups) g
   , (select id from qo_modules where module_id like 'qo-widgets') m;