Ext.ux.FlashPlugin = function() {
    this.init = function(ct) {
        ct.flashTemplate = new Ext.XTemplate(
            '<div>',
            '<object id="flash-{id}" classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" width="{swfWidth}" height="{swfHeight}">',
            '<param name="movie" value="{swf}" />',
            '<param name="quality" value="high" />',
            '<param name="wmode" value="transparent" />',
            '<param name="flashvars" value="{computedflashvars}" />',
            '<param name="allowScriptAccess" value="domain" />',
            '<param name="align" value="t" />',
            '<param name="salign" value="TL" />',
            '<param name="bgcolor" value="#000000" />',
            '<param name="swliveconnect" value="true" />',
            '<param name="scale" value="noscale" />',
            '<embed name="flash-{id}" src="{swf}" bgcolor="#000000" quality="high" pluginspage="http://www.macromedia.com/go/getflashplayer" flashvars="{computedflashvars}" type="application/x-shockwave-flash" width="{swfWidth}" height="{swfHeight}" wmode="transparent" allowScriptAccess="always" swliveconnect="true" align="t" salign="TL" scale="noscale"></embed>',
            '</object>',
            '</div>'
        );
        ct.flashTemplate.compile();
        ct.renderFlash = function() {
            if (this.flashvars && (typeof this.flashvars == 'object')) {
                var tempflashvars = Ext.apply({}, this.flashvars);
                for (var key in tempflashvars) {
                    if (typeof tempflashvars[key] == 'function') {
                        tempflashvars[key] = tempflashvars[key].call(this, true);
                    } 
                };
                this.computedflashvars = Ext.urlEncode(tempflashvars);
            }
            this.swfHeight = this.body.getSize().height -2;
            this.swfWidth = this.body.getSize().width -2;
            if (this.body.first()) this.flashTemplate.overwrite(this.body.first(),this);
            else this.flashTemplate.insertFirst(this.body,this);
        };
        ct.loadFlash = function(config) {
            Ext.apply(this,config);
            this.renderFlash();
        };
        ct.on('afterlayout',ct.renderFlash, ct);
    };
};

ImageDragZone = function(view, config, scope){
    this.view = view;
    this.scope = scope;
    ImageDragZone.superclass.constructor.call(this, view.getEl(), config);
};

Ext.extend(ImageDragZone, Ext.dd.DragZone, {

    getDragData : function(e){
        var target = e.getTarget('.qo-widgets-thumb-wrap');
        if(target){
            var view = this.view;
            if(!view.isSelected(target)){
                view.onClick(e);
            }
            var selNodes = view.getSelectedNodes();
            var dragData = {
                nodes: selNodes
            };
            if(selNodes.length == 1){
                dragData.ddel = target;
                dragData.single = true;
            }else{
                var div = document.createElement('div'); // create the multi element drag "ghost"
                div.className = 'multi-proxy';
                for(var i = 0, len = selNodes.length; i < len; i++){
                    div.appendChild(selNodes[i].firstChild.firstChild.cloneNode(true)); // image nodes only
                    if((i+1) % 3 == 0){
                        div.appendChild(document.createElement('br'));
                    }
                }
                var count = document.createElement('div'); // selected image count
                count.innerHTML = i + ' images selected';
                div.appendChild(count);
                dragData.ddel = div;
                dragData.multi = true;
            }
            return dragData;
        }
        return false;
    },
    endDrag: function(e) {

	var s = this.view.getSelectedRecords();
	var launcherName = s[0].data.launcher;

	var launcher = eval("Ext.Widget."+launcherName);
	var posX = e.getPageX();
	var posY = e.getPageY();

	var widgetID = 'qo-widgets-'+this.scope.uniqID();

	launcher(e.getPageX(), e.getPageY(), widgetID);

	// Save in DB for reload & position
	this.scope.saveWidget(widgetID, launcherName, posX, posY);

    },

    // the default action is to "highlight" after a bad drop
    // but since an image can't be highlighted, let's frame it 
    afterRepair:function(){

        for(var i = 0, len = this.dragData.nodes.length; i < len; i++){
            Ext.fly(this.dragData.nodes[i]).frame('#8db2e3', 1);
        }
        this.dragging = false;
    }
});

var widgetsWin = new Ext.WindowGroup();
widgetsWin.zseed = 100;

Ext.namespace('Ext.Widget');

Ext.ux.Widget = Ext.extend(Ext.Window, {
    initComponent:function() {

	this.goToX = this.goToX || false;
	this.goToY = this.goToY || false;

	Ext.apply(this, {
        title: '',
	closable:true,
        closeAction:'close',
        manager: widgetsWin,
	footer :false,
	header :false,
	collapsible:false,
	draggable:true,
	plain:true,
	layout:'fit'

	}); // e/o apply
	
	// call parent
	Ext.ux.Widget.superclass.initComponent.apply(this, arguments);

	this.show();
 
    }, // end of function initComponent

    afterRender: function() {
	// call parent
	Ext.ux.Widget.superclass.afterRender.apply(this, arguments);

        this.tools.close.hide();

	var mod = this.scope.QoDesk.getModule('qo-widgets');

	this.el.on('mouseover', function() {
                    this.tools.close.show();
                    this.setTitle(mod.storeWidget.getById(this.launcher).data.title);
        }, this);

	this.el.on('mouseout', function()  {
                    this.tools.close.hide();
                    this.setTitle('');
        }, this);

	this.on('move', function(comp, x, y) {
                    mod.savePositionWidget(this.id, x, y);
	}, this);

        this.on('close', function() {
                    mod.closeWidget(this.id);
	}, this);

        this.on('resize', function(win, NewWidth, NewHeight) {
                    mod.resizeWidget(this.id, NewWidth, NewHeight);
	}, this);

	// If goToX / goToY are defined, we move the widget
	if( this.goToX && this.goToY ) {
                this.setPagePosition(this.goToX, this.goToY);
	}

    } // e/o afterRender
});

QoDesk.QoWidgets = Ext.extend(Ext.app.Module, {

	moduleType : 'widgets',
	moduleId : 'qo-widgets',
        menuPath   : 'StarMenu/Tools',

	storeWidget: '',
	tplInfoWidget: '',
	bottomDrawer: '',
	
	init : function(){
		this.launcher = {
			handler: this.createWindow,
			iconCls: 'qo-widgets-icon',
			scope: this,
			shortcutIconCls: 'qo-widgets-shortcut-icon',
			text: 'Widgets',
			tooltip: '<b>Widgets</b><br />Some widgets for your Desktop !'
		}
	},

	createWindow : function() {

	//Init DD target for the desktop
	Ext.get('x-desktop').initDDTarget('widgetDD');

          var desktop = this.app.getDesktop();
          var win = desktop.getWindow('qo-widgets');

          if(!win){

                this.storeWidget = new Ext.data.JsonStore({
                        baseParams: {
                                moduleId: this.moduleId,
                                fileName: 'php/loadAvailableWidgets.php'
                        },
                        fields: ['launcher', 'title', 'IconPreview', 'version', 'author','description', 'file_js', 'file_css'],
                        id: 'launcher',
                        root: 'widget',
                        url: this.app.connection
                });

		var tplWidget = new Ext.XTemplate(
			'<tpl for=".">',
			'<div class="qo-widgets-thumb-wrap" id="{title}">',
			'<div class="qo-widgets-thumb"><img src="{IconPreview}" title="{title}"></div>',
			'<span>{title}</span></div>',
			'</tpl>',
			'<div class="x-clear"></div>'
		);

		this.tplInfoWidget = new Ext.XTemplate(
			'<tpl for=".">',
			'<div class="qo-widgets-InfoWidget">',
			'<img src="{IconPreview}" title="{title}" />',
			'<div class="qo-widgets-InfoWidget-title">{title}</div>',
			'<div class="qo-widgets-InfoWidget-ver">ver. {version} by {author}</div>',
			'<div class="qo-widgets-InfoWidget-desc"><blockquote>{description}</blockquote></div></div>',
			'</tpl>'
		);

		this.bottomDrawer = new drawer({
			size      : 130,
			side      : 's',
			animate   : true,
			plain     :  true,
			layout    : 'fit'
		});

            win = desktop.createWindow({
                autoScroll: true,
                id: 'qo-widgets',
                title: 'Widgets',
                width:640,
                height:280,
                iconCls: 'qo-widgets-icon',
                items : new Ext.DataView({
			scope: this,
			id:'vListWidget',
			store: this.storeWidget,
			tpl: tplWidget,
			autoHeight:true,
			multiSelect: true,
			overClass:'x-view-over',
			itemSelector:'div.qo-widgets-thumb-wrap',
			emptyText: 'No widget to display',
			listeners: {
				scope: this,
				dblclick: function(dv, NumberIndex, node, e) {
					var s = dv.getSelectedRecords();
					var launcherName = s[0].data.launcher;
					var launcher = eval("Ext.Widget."+launcherName);
					var widgetID = 'qo-widgets-'+this.uniqID();
					launcher(0, 0, widgetID);
					// Save in DB for reload & position
					this.saveWidget(widgetID, launcherName, 0, 0);
				},
				click: function(dv, NumberIndex, node, e) {
					this.tplInfoWidget.overwrite(this.bottomDrawer.body, this.storeWidget.data.items[NumberIndex].data);
                                        var e = win.drawers.s.getState();
                                        if( e.x < 0 ) { win.drawers.s.show(); }
				},
                                render: function() {
                                        this.storeWidget.load();

                                        this.storeWidget.on('load', function() {

                                            var i;
                                            for( i=0; i < this.storeWidget.data.length; i++ ) {

                                              var s = document.createElement("script");
                                              s.src = this.storeWidget.data.items[i].data.file_js;
                                              s.type = 'text/javascript';
                                              document.getElementsByTagName("head")[0].appendChild(s);

                                              // Load Css file if exist
                                              if( this.storeWidget.data.items[i].data.file_css != '' ) {
                                                var s = document.createElement("link");
                                                s.href = this.storeWidget.data.items[i].data.file_css;
                                                s.type = 'text/css';
                                                s.rel = 'stylesheet';
                                                document.getElementsByTagName("head")[0].appendChild(s);
                                              }

                                              var launcher = eval('Ext.Widget.'+this.storeWidget.data.items[i].data.launcher);

                                              var wait = new Ext.util.DelayedTask(function() {

                                                if( typeof launcher == "undefined" ) {
                                                  wait.delay(1000);
                                                }

                                               });
                                               wait.delay(1000);


                                            }

                                            //Restaure Widget
                                            this.loadWidget();

                                        },this);

                                }

			}
		}),
                shim:false,
                animCollapse:false,
                constrainHeader:true,
                maximizable: false,
                bbar: [{
			text:'Details',
                        iconCls: 'qo-widgets-details-icon',
			scope:this,
			handler:function() {
				var e = win.drawers.s.getState();
				if( e.x < 0 ) {
					win.drawers.s.show();
				} else {
					win.drawers.s.hide();
				}
			}
		},'->',{
                        text:'Hide all',
                        handler: function() {
                            widgetsWin.hideAll();
                        }

                },{
                        text:'Show all',
                        handler: function() {
                            widgetsWin.each(function(win){ win.show();}, this);
                        }

                },{
                        text:'Re-Order',
                        handler: function() {
                            var nX=80;
                            var nY=20;

                            widgetsWin.each(function(win){
                              nY = nY + 30;
                              nX = nX + 30;
                              win.setPagePosition(nX, nY);
                            }, this);

                        }

                }],
                taskbuttonTooltip: '<b>Widgets</b>',
		plugins : [
			this.bottomDrawer
		]
            });
        }
        win.show();

	//DD for the view
	var dragZone = new ImageDragZone(Ext.getCmp('vListWidget'), {containerScroll:true,
        ddGroup: 'widgetDD'}, this);

    },

    saveWidget: function(widgetID, launcherName, posX, posY) {
	Ext.Ajax.request({
		url: this.app.connection,
		params: {
			moduleId: this.moduleId,
			fileName: 'php/save.php',
			widgetID: widgetID,
			launcherName: launcherName,
			posX: posX,
			posY: posY
		}
	});
    },

    closeWidget: function(widgetID) {
	Ext.Ajax.request({
		url: this.app.connection,
		params: {
			moduleId: this.moduleId,
			fileName: 'php/close.php',
			widgetID: widgetID
		}
	});
    },

    savePositionWidget: function(id, x, y) {

	Ext.Ajax.request({
		url: this.app.connection,
		params: {
			moduleId: this.moduleId,
			fileName: 'php/setPos.php',
			widgetID: id,
			posX: x,
			posY: y
		}
	});

    },

    resizeWidget: function(id, NewWidth, NewHeight) {

	Ext.Ajax.request({
		url: this.app.connection,
		params: {
			moduleId: this.moduleId,
			fileName: 'php/resize.php',
			widgetID: id,
			NewHeight: NewHeight,
			NewWidth: NewWidth
		}
	});

    },

    loadWidget: function() {

	Ext.Ajax.request({
		scope: this,
		url: this.app.connection,
		params: {
			moduleId: this.moduleId,
			fileName: 'php/load.php'
		},
		success: function(o){
			if(o && o.responseText && Ext.decode(o.responseText).success){
				var r = Ext.decode(o.responseText);
				if( r.nb > 0 ) {
					for( i=0; i < r.widget.length; i++ ) {
						var launcherName = r.widget[i].launcher;
						var widgetID = r.widget[i].id;
						var posX = r.widget[i].posX;
						var posY = r.widget[i].posY;
						var wWidth = r.widget[i].wWidth;
						var wHeight = r.widget[i].wHeight;

						var launcher = eval("Ext.Widget."+launcherName);
						launcher(posX, posY, widgetID, wWidth, wHeight);
					}
				}
			}else{

			}
		}
	});

    },

    uniqID : function() {
	var uniqID = new Date();
	return uniqID.getTime();
    }

});